/***************************************************************************
                          cdb.h  -  description
                             -------------------
    begin                : Thu Jan 23 2003
    copyright            : (C) 2003 by Oleksiy Kohany
    email                : kohany@girinst.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CDB_H
#define CDB_H

#include <map>
#include <string>
#include <fstream>
#include "constants.h"
#include "badfilename_exception.h"
#include "BioSequence.h"

using namespace std;

#ifndef MAXLINELENGTH 
#define MAXLINELENGTH 255
#endif
#ifndef MAXNAMESIZE 
#define MAXNAMESIZE 255
#endif
/**
  *@author Oleksiy Kohany
  */

class CLP {
   public:
   long headPos;
   string fname;
   long dataPos;

   CLP() {
      headPos = 0;
      dataPos = 0;
   }
   CLP(const string& fn, long hp, long dp) {
      headPos = hp;
      dataPos = dp;
   }
   /** No descriptions */
   void assign(const string& fn, long hp, long dp){
      fname = fn;
      headPos = hp;
      dataPos = dp;
   }
   /** No descriptions */
   void assign(const char* fn, long hp, long dp){
      fname = fn;
      headPos = hp;
      dataPos = dp;
   }
};

ostream& operator << (ostream& os, CLP& lp);

typedef map<string, CLP> LPMAP;

class CDb {
  LPMAP lpmap;
  /**  */
#ifdef IOSTREAM
  ifstream *ifs;
#else
  FILE *ifs;
#endif
  /**  */
  long iLastPos;
  /**  */
  string sDbDir;
  /**  */
  string sDbName;
  /**  */
  string sIDX;
  /**  */
  unsigned int iIDXSize;
  /** No descriptions */
  int findLocus(const char* locus);
  /** No descriptions */
  int open_ifs(const char *fn);
  /** No descriptions */
  void close_ifs();
  /** No descriptions */
  void rewind_ifs();
  /** No descriptions */
  long fragment(long iF, long iT, string& sq, bool bGap=0);
  /** No descriptions */
  long getWidth();
  /** No descriptions */
  int loadIndexUpToDate(const char* fdb, const char* idx);
  /** No descriptions */
  int loadIdx(const char *fn);
public: 
	CDb(const char* fname);
	~CDb();
  /** No descriptions */
  long getDataPos(const char* locus);
  /** No descriptions */
  long getHeadPos(const char* locus);
  /** No descriptions */
  void saveIdx(const char* fn);
  /** No descriptions */
  void saveIdx(FILE* fn);
  /** No descriptions */
#ifdef IOSTREAM
  ifstream* getData(const char* locus);
#else
  FILE* getData(const char* locus);
#endif
  /** No descriptions */
  bool exist(const char *pcFName);
#ifdef IOSTREAM
  /** No descriptions */
  ifstream* getHead(const char* locus);
#else
  FILE* getHead(const char* locus);
#endif
  /** No descriptions */
  long fragment(const char* pcName, long iF, long iT, BioSubSequence& sq, bool bGap=0);
  /** No descriptions */
  static long fragment(ifstream* ifs, long iCnt, string& sq, bool bGap=0);
  /** No descriptions */
  static long fragment(FILE* ifs, long iCnt, string& sq, bool bGap=0);
};

int cmpage(const char* name1, const char* name2);

#endif
