#ifndef _SEGMENT_H_
#define _SEGMENT_H_

#include "functions.h"
#include <iostream>

using namespace std;

class segment {
  double m_dFrom;
  double m_dTo;
 public:
  segment() {
    m_dFrom = m_dTo = 0;
  }
  segment(double dFrom, double dTo) {
    assign( dFrom, dTo);
  }
  segment(int iFrom, int iTo) {
    assign(iFrom, iTo);
  }
  void assign(double dFrom, double dTo);
  segment& erase();
  double getLength() const;
  double getFrom() const;
  double getTo() const;
  void setFrom(double dFrom);
  void setTo(double dTo);
  bool overlaps(const segment& seg) const;
  bool contains(const segment& seg) const;
  bool inside(const segment& seg) const;
  segment& add(const segment& seg);
  segment& sub(const segment& seg);
  long dist(const segment& seg) const;
  void print(FILE* fout) const;
  void print(ostream& os) const;
  /** No descriptions */
  virtual segment& operator = (const segment& seg);
};
//=====================================================
ostream& operator << (ostream& os, const segment& seg);

#endif // _SEGMENT_H_
