#ifndef _SEQDB_H_
#define _SEQDB_H_

#include "constants.h"
#include <stdio.h>
#include <map>
#include <string>
#include <string.h>

using namespace std;

class CLocusPos;
typedef map<string, CLocusPos> POSMAP;

class CLocusPos {
 public:
  char *m_pcFName;
  long m_iCom;
  long m_iPos;
  static char ssPath[MAXNAMESIZE];
  static bool SHOWCOMMENT;
//-------------------------------------------
  CLocusPos(const char *pcFName, const long iCom, const long iPos) {
    m_pcFName = NULL;
    assign(pcFName, iCom, iPos);
  }
//-------------------------------------------
  CLocusPos() {
    m_iCom = m_iPos = -1;
    m_pcFName = NULL;
  }
//-------------------------------------------
  ~CLocusPos() {
    if(m_pcFName != NULL) {
      delete m_pcFName;
    }
  }
//-------------------------------------------
  void assign(const char *pcFName, const long iCom, const long iPos);
//-------------------------------------------
  CLocusPos& operator = (const CLocusPos &Pos);
//-------------------------------------------
  long getPos() const;
};

//===========================================
class CSdb {
  FILE *m_pFDB;
  char m_sDBName[MAXNAMESIZE];
  char m_sIDXName[MAXNAMESIZE];
  POSMAP m_pmap;
  long m_iPos;
 public:
//-------------------------------------------
  CSdb(const char *pcDBName) {
    FILE *pFIDX;
    m_pFDB = fopen(pcDBName, "r");
    strcpy(m_sDBName, pcDBName);
    strcpy(m_sIDXName, pcDBName);
    strcat(m_sIDXName, ".idx");
    pFIDX = fopen(m_sIDXName, "r");
    if(pFIDX != NULL) {
      loadIndex(pFIDX, m_pmap);
      fclose(pFIDX);
    }
    else {
      if(m_pFDB == NULL) {
	throw "CSdb::CSdb(char *pcDBName) : no data loaded.";
      }
    }
  }
//-------------------------------------------
  ~CSdb() {
    FILE *pFIDX;
    fclose(m_pFDB);
    if((pFIDX = fopen(m_sIDXName, "w")) != NULL) {
      saveIndex(pFIDX, m_pmap);
      fclose(pFIDX);
    }
  }
//-------------------------------------------
  static FILE* findLocus_File(FILE *INF, const char *pcFName, const char *pLName, POSMAP &pmap);
//-------------------------------------------
  static FILE* findLocus_Map(const char *pLName, const POSMAP &pmap);
//-------------------------------------------
  FILE *getLocus(const char *pLName);
//-------------------------------------------
  static int loadIndex(FILE *F, POSMAP &pmap);
//-------------------------------------------
  static void saveIndex(FILE *F, const POSMAP &pmap);
};

#endif //_SEQDB_H_
